/*  Copyright 2008 Peter Mora
 *
 *  This file is part of Vakarcs.
 *
 *  Vakarcs is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Vakarcs is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Vakarcs.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <iostream>
#ifdef __WIN32__
 #include "socket/tcpsocket.hh"
#else
 #include "tcpsocket.hh"
#endif
//#include "curses.h"
#include "ui.h"

int main(int argc, char **argv)
{
	int			port;
	Network::TcpSocket	client;

	unsigned int		player_id;
	unsigned int		game_id;

	Ui			ui;
	ui.load_language("language_hu.txt"); //Finish it later

	char	tmp[100];

//	std::cout << "Usage : " << argv[0] << " [host [port]]" << std::endl;
	std::cout << "Használat : " << argv[0] << " [szerver [port]]" << std::endl;
	if (argc > 3 )
	{
		return 1;
	}
	if (argc == 3)
		port = strtol(argv[2], 0, 10);
	else
		port = 5555;
	if (port <= 0)
	{
		std::cerr << "Érvénytelen port!" << std::endl;
		return 1;
	}
	bool connected = false;
	std::string host;
	host = "127.0.0.1";
	if (argc > 1)
		host = argv[1];
//	std::cout << "Connecting to " << host.c_str() << " on port "<< port <<" ";
	std::cout << "Kapcsolódás " << host.c_str() << " szerverhez "<< port <<" porton ";
	std::string str;
	do
	{
		try
		{
			//      if (argc > 2)
			//	client.init_tls(Network::LIBSOCKET_TLS);
			client.connect(host, port);
			std::cout << "OK" << std::endl;
			//      if (argc > 2)
			//	client.enable_tls();
			client.add_delim("\n");
			client.add_delim("\r\n");
			client << "WANNA PLAY\n";
			client << VERSION << "\n";
			client >> str;
			if (str == "Let's start")
			{
				connected = true;
			}
			else
			{
				std::cout << str << std::endl;
				return 1;
			}
		}
		catch (Network::Exception &e)
		{
			std::cout << ".";//<< std::endl;
			std::cout.flush();
			usleep(300000);
		//	std::cout << "Reconnecting ... ";
		}
	}while(connected == false);
	try{
		client >> str;
		player_id = atol(str.c_str());
		client >> str;
		int number_of_players = atol(str.c_str());
		ui.set_player_id(player_id,number_of_players);
		std::cout << "Player ID: " << player_id << std::endl;
		client >> str;
		game_id = atol(str.c_str());
		std::cout << "Game ID: " << game_id;
		int x,y;
		client >> str;
		x = atol(str.c_str());
		client >> str;
		y = atol(str.c_str());
		ui.setxy(x,y);
		client >> str;
		ui.set_abilities(str);
		client.close();
	}
	catch (Network::Exception &e){ std::cout << "\nProbléma a szerverrel." << std::endl; return 2; }

	std::string sendstr;
	bool send = false;
	bool play = false;

	std::string old;

	while(true)
	{
		try
		{
			client.connect(host, port);
//			client.add_delim("\n");
//			client.add_delim("\r\n");
			if (send)
			{
				client << "Transmitting data.\n";
			}
			else
			{
				client << "Give me data\n";
			}

			sprintf(tmp,"%d",player_id);
			client << tmp << "\n";
			sprintf(tmp,"%d",game_id);
			client << tmp << "\n";

			client >> str;

			if (str != old)
			       	std::cout << "\nSzerver üzenete: " << str;
			else
				std::cout << ".";
			std::cout.flush();
			old = str;
//			if (str == "Game over")
//			{
//				exit(0);
//			}
			if (str == "Transmitting data." && !send)
			{
				client >> str;
				ui.message(str);
				play = true;
			}
			if (str == "Receiving." && send)
			{
				client << sendstr.c_str() << "\n";
				if (sendstr == "exit")
				{
					cout << "\nA szervertől elbúcsúztunk.\n";
					return 0;
				}
				send = false;
			}

			client.close();
			if (play)
			{
				sendstr = ui.play();
				if (sendstr == "quit")
					return 0;
				send = true;
				play = false;
			}
			usleep(300000);
		}
		catch (Network::Exception &e)
		{
			std::cout << std::endl << e << std::endl;
			std::cout << "A szerver nem elérhető. (Van net? A szerver fut még?)" << std::endl;
			usleep(300000);
		}
	}
	return 0;
}
